/* PIPEXT.H contains declarations for some global variables */

#ifdef MAIN
#define EX
extern unsigned _stklen=65535;
#else
#define EX extern
#endif

EX uint key_number;

EX FILE *f,*flog;
EX char fn[128],lbuff[256];
EX struct time tm;
EX struct date dt;

EX uint registered;

EX NODEINFO cfg;

EX char origins[256][60];

EX AREASTRUCT *areas;

#define SET_MARK 1
#define SET_DEL 2
#define SET_NEW 4

#ifdef MAIN

  char *mname[12]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
  unsigned char bitmp[8]={1,2,4,8,16,32,64,128};
  unsigned char bitmn[8]={254,253,251,247,239,223,191,127};

  logg(char c,char *s,int l)
  {
    if (flog && (l<=cfg.loglevel))
      {
        gettime(&tm);
        getdate(&dt);
        if(cfg.logtype)
          fprintf(flog,"%c %02d:%02d:%02d %s\n",c,tm.ti_hour,tm.ti_min,tm.ti_sec,s);
        else
          fprintf(flog,"%02d %s %d %02d:%02d:%02d %s %s\n",dt.da_day,mname[dt.da_mon-1],dt.da_year,tm.ti_hour,tm.ti_min,tm.ti_sec,PRGRM,s);
      }
    return 0;
  }


  openlog()
  {
    int c=0;
    flog=NULL;
    if (*cfg.logfilename)
      {
        if(access(cfg.logfilename,0))
          {
            flog=fopen(cfg.logfilename,"w");
            c=1;
          }
        else
          flog=fopen(cfg.logfilename,"a");
      }
    getdate(&dt);
    if (cfg.logtype)
      fprintf(flog,"---------- %02d %s %d %s %d.%02d\n",dt.da_day,mname[dt.da_mon-1],dt.da_year,PROGRAM,PIPBASEVERSION,PIPBASESUBVERSION);
    if (c)
      logg(' ',"Log file created",3);
    return 0;
  }


  closelog()
  {
    if (flog) {logg(' ',"End.",3); fprintf(flog,"\n"); fclose(flog);}
    return 0;
  }


  esci(char *m)
  {
    fprintf(stderr,"%s\7\n",m);
    logg('!',"***ERROR***ERROR***ERROR***",3);
    logg('!',m,0);
    free(areas);
    closelog();
    exit(1);
    return 0;
  }

#else

  extern char *mname[12];
  extern unsigned char bitmp[8],bitmn[8];

#endif

#define isbit(w,bitmap) (bitmap[w/8]&bitmp[w%8])
#define setbit(w,bitmap) bitmap[w/8]|=bitmp[w%8]
#define resetbit(w,bitmap) bitmap[w/8]&=bitmn[w%8]
