// help procedures for PipBase.Exe 


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>

#include "version.h"

void help_addroute()
{
  cout << "PIPBASE ADDROUTE friend# ALL\n";
  cout << "PIPBASE ADDROUTE friend# ZONE zone#\n";
  cout << "PIPBASE ADDROUTE friend# NET zone# net#\n";
  cout << "PIPBASE ADDROUTE friend# HUB zone# net# hub#\n";
  cout << "PIPBASE ADDROUTE friend# NODE zone# net# node#\n";
  cout << "PIPBASE ADDROUTE friend# POINT zone# net# node# point#\n\n";
  cout << "Each of these commands defines a routing rule for packed matrix\n";
  cout << "messages. Routing means that all messages for a group of nodes will be\n";
  cout << "packed togheter and sent to a single node (\"host\" or \"hub\").\n\n";
  cout << "All target nodes have to be defined with SETFRIEND (see) before\n";
  cout << "you route something via them. Each commands tells to the system to\n";
  cout << "route the specified point, node (or the cluster of the node and all his\n";
  cout << "points), hub, net or zone via the specified \"target\" friend.\n";
  cout << "You may see the routing rule list with LISTROUTE (see) and remove\n";
  cout << "routing rules with DELROUTE (see).\n\n";
  cout << "Points wanting to route all their mail via their boss (that is the most\n";
  cout << "natural thing, and points not following this rule are very rare) don't\n";
  cout << "need a ROUTE boss_friend# ALL: it's a default.\n";
}


void help_areafix()
{
  cout << "PIPBASE AREAFIX\n\n";
  cout << "This is the first Robot inserted in PipBase.\n\n";
  cout << "Its function is simple: when a point or another BBS wants to be linked to a\n";
  cout << "conference (see SETEXPORT), the sysop has to write a #NETMAIL message to the\n";
  cout << "user called \"Areafix\" on the conference feeder (the boss, if you're a point),\n";
  cout << "containing as subject your areafix password (contact the feeder sysop for\n";
  cout << "obtaining it), and in the text the tag names of the conferences you desire.\n";
  cout << "When you're bored of an echomail area, you may unlink it simply by addressing\n";
  cout << "a message to Areafix and specifying the tag names of the conferences you don't\n";
  cout << "want any more, preceeded by a minus. By example: if you want to detach\n";
  cout << "yourself from the conference CHATTER.ITA, you'll have to specify -CHATTER.ITA\n";
  cout << "in the text of the message.\n";
  cout << "If you place a -Q in the subject of the message (after the password, of course),\n";
  cout << "you'll receive the listing of all conferences you're linked to; if you place a\n";
  cout << "-L (the case doesn't matter), you'll receive the list of all conferences\n";
  cout << "supported by your feeder; if you put a -H, you'll receive a complete help on\n";
  cout << "how to use AreaFix.\n";
  cout << "Notice: areas with an areafix level greater than your are not listed with a -L.\n\n";
  cout << "When the feeder runs PIPBASE AREAFIX, the Area Robot scans all netmail\n";
  cout << "messages and answers them.\n\n";
  cout << "Important: to have this function, your boss has to register (see BOOST)!\n";
}


void help_boost()
{
  cout << "PIPBASE BOOST key|NULL\n\n";
  cout << "When your registration key arrives in the form of an intricate sequence of\n";
  cout << "letters and digits, type PIPBASE BOOST \"that-sequence\", to place the key into\n";
  cout << "PipBase. It will open a lot of new possibilities!\n\n";
  cout << "To obtain the key, please read allegated docs and/or contact the author (see\n";
  cout << "PIPBASE INFO).\n\n";
  cout << "If, for any reason, you're bored of being registered, type PIPBASE BOOST NULL\n\n";
  cout << "Important notice: since in your key there is (coded) your name, you cannot modify\n";
  cout << "user#0 after you required the key.\n\n";
  cout << "Another important notice: you have an unique key for all Pip! programs.\n\n";
  cout << "Remember that PipBase is shareware, and paying a registration key is the best\n";
  cout << "way to say Thank You to the author.\n";
}


void help_create()
{
  cout << "PIPBASE CREATE is the command to create a message area.\n";
  cout << "Syntax is:\nPIPBASE CREATE area# \"description\" #LOCAL|#NETMAIL|#BAD|#DUPES message# day#\n";
  cout << "or PIPBASE CREATE area# \"description\" echotag message# day# origin#\n";
  cout << "Where area# is the area number, from 0 to the maximum area number (see PIPBASE\n";
  cout << "SET for informations about the number of areas allowed for each model) that you\n";
  cout << "defined when you ran PIPBASE SET.\n";
  cout << "Description is a description of the contents of the area.\n";
  cout << "Tagname is the echomail tag (if the area is an echo area, a conference shared\n";
  cout << "by multiple BBS; contact the Echomail Coordinator or your boss for more\n";
  cout << "informations), or the keyword #NETMAIL (indicating an area for matrix\n";
  cout << "messages), #LOCAL (messages here will never be exported), #BAD (if you want in\n";
  cout << "this area all messages arriving with unknown echotags) or #DUPES (defining an\n";
  cout << "area to store duplicate messages).\n";
  cout << "message# is the number of messages the area will contain. If it is 0, the area\n";
  cout << "treated as a Passthru area, and all messages will be deleted immediately after\n";
  cout << "a PIPBASE EXPORT. See PURGE for more informations.\n";
  cout << "day# is the maximum number of days the messages will stay in your disk (see\n";
  cout << "also PURGE).\n";
  cout << "origin#: when you define an echomail area, you must associate to it an origin,\n";
  cout << "a phrase that will be appended to each message to identify the sender's BBS;\n";
  cout << "you've to set a list of origins (see SETORIGIN) and then associate one of them\n";
  cout << "to each area (see also PICKORIGIN).\n";
  cout << "If you're creating an echomail area, remember to issua elso a SETEXPORT (see)\n";
  cout << "command to link the conference to all others BBSes and/or points.\n";
}


void help_delete()
{
  cout << "PIPBASE DELETE area# message#\n";
  cout << "\n";
  cout << "It deletes the message message# form the area number area#.\n";
  cout << "\n";
  cout << "Warning: it marks only the message as deleted, but it doesn't erase it form \n";
  cout << "the disk. You may recover it with PIPBASE UNDELETE or scratch it with PIPBASE\n";
  cout << "PACK.\n\n";
  cout << "With PIPBASE DELETE you may override the PIPBASE LOCK option.\n\n";
  cout << "See also LOCK, PACK, PURGE and UNDELETE.\n";
}


void help_delroute()
{
  cout << "PIPBASE DELROUTE rule#\n\n";
  cout << "This command removes the rule number rule# from the routing file.\n";
  cout << "Rule numbers are assigned automatically when you run PIPBASE ADDROUTE (see)\n";
  cout << "and shown by PIPBASE LISTROUTE (see).\n\n";
  cout << "Warning: when you execute a DELROUTE, all routing rules are renumbered.\n\n";
}


void help_destroy()
{
  cout << "PIPBASE DESTROY area#\n\n";
  cout << "This command destroys a message area.\n";
  cout << "All messages in the area will be lost, and the area description will be\n";
  cout << "removed form area list.\n\n";
  cout << "Be cautious!\n";
}


void help_export()
{
  cout << "PIPBASE EXPORT\n\n";
  cout << "It seeks all the message base looking for new messages. If there are new \n";
  cout << "messages in exported areas (i.e.: in netmail area, addressed to other nodes, \n";
  cout << "or in echomail areas, for which there are other nodes in the chain), they will \n";
  cout << "be packed accordingly to the SETFRIEND, SETATTACHES (see), SETEXPORT (see) and \n";
  cout << "ADDROUTE (see) directives.\n\n";
  cout << "When enabled (and unless your friend is marked as HOLD), your mailer will \n";
  cout << "deliver mail bundles.\n\n";
  cout << "When a message is packed in an outgoing bundle, it's marked as \"Sent\". If it\n";
  cout << "was a netmail (or matrix) message marked as \"Kill Sent\", it will be also\n";
  cout << "deleted.\n";
}


void help_ghost()
{
  cout << "PIPBASE GHOST\n\n";
  cout << "This command scans all your #NETMAIL area, sending a receipt request for each\n";
  cout << "message it founds, even if the ReturnReceiptRequest flag is set to off.\n";
  cout << "A standard message is always generated; if you defined a file with SETRR (see),\n";
  cout << "that file will be appended to the standard text.\n\n";
  cout << "It flags all processed mesages as Received.\n\n";
  cout << "Important: if you use PIPBASE GHOST, you should'nt use also PIPBASE RR.\n\n";
  cout << "See also: RR, SETGHOST and SETRR.\n\n";
  cout << "This option is enabled in registerd version only.\n";

}


void help_help()
{
  cout << "PIPBASE HELP [command]\n\n";
  cout << "To know all about a particular command or a setting, type PIPBASE HELP\n";
  cout << "followed by the command you want to know all about. If it's a SETxxxxx\n";
  cout << "comand, you'll be informed also on what means that setting.\n\n";
  cout << "PIPBASE HELP without parameters shows the command list.\n\n";
  cout << "Square backets are used to indicate optional parameters.\n";
  cout << "The pipe sign (|) means \"choose one or another\".\n\n";
  cout << "A # after a formal parameter indicates that the parameter has to be a decimal\n";
  cout << "number.\n";
}


void help_import()
{
  cout << "PIPBASE IMPORT\n\n";
  cout << "It looks if there are mail packets in the inbound directory, unpacks them and\n";
  cout << "places them in the proper message area.\n\n";
  cout << "If a message belonging to an undefined conference is found, it will be placed\n";
  cout << "in the #BAD area (if defined; otherwise it will be lost).\n\n";
  cout << "Each conference is identified by a conventional tagname.\n\n";
  cout << "See also CREATE and EXPORT.\n";
}


void help_index()
{
  cout << "PIPBASE INDEX [area#|DESTPTR]\n\n";
  cout << "This command regenerates PipBase index files.\n";
  cout << "It may be useful when they're corrupted.\n";
  cout << "If you specify the area number, only the index for the specified area\n";
  cout << "will be regenerated\n\n";
  cout << "Since Destptr.Pip is an unique index for all areas, it will always be\n";
  cout << "recreated for all areas: It's not a bug!\n\n";
  cout << "Important: in regenerating index files, PipBase cannot know which messages\n";
  cout << "were locked and which deleted, since these informations were stored in the\n";
  cout << "corrupted index file, so you'll have to re-lock and re-purge the messages.\n";
  cout << "Don't use this option unless necessary.\n\n";
  cout << "If you specify DESTPTR instead of an area number, only DestPtr.Pip will be\n";
  cout << "generated. This file contains only a copy of the addressee names, and so a\n";
  cout << "PIPBASE INDEX DESTPTR doesn't destroy any bit.\n";
}


void help_info()
{
  cout << "PIPBASE INFO\n\n";
  cout << "This command prints informations about the PipBase project and its authors\n";
  cout << "without forgetting acknowledgements to all peoples that helped us in\n";
  cout << "developing this great product\n.\n";
}


void help_link()
{
  cout << "PIPBASE LINK [area#]\n\n";
  cout << "Messages are sorted to make a \"Reply Chain\", i.e. to have a linked list\n";
  cout << "of all messages with the same subject; it's useful with most editors.\n\n";
  cout << "A LINK is suggested after each IMPORT, or once a day.\n";
  cout << "PIPBASE PACK (see) performs automatically also a LINK.\n";
  cout << "I suggest to perform always a PIPBASE LINK after a PIPBASE IMPORT\n";
}


void help_listakas()
{
  cout << "PIPBASE LISTAKAS\n\n";
  cout << "It presents the list of all defined addresses.\n\n";
  cout << "Addess #0 is your main address; all others are \"aka\"s (A.K.A.=Also\n";
  cout << "Known As...) or secondary addresses.\n\n";
  cout << "It also displays the settings of the fakenet and of the \"UUCP\" internet\n";
  cout << "gateways\n\n";
  cout << "See also SETNODE and SETUUCP\n";
}


void help_listarea()
{
  cout << "PIPBASE LISTAREA area# [NEW]\n\n";
  cout << "It lists all the headers of the messages contained in area area#.\n\n";
  cout << "See READAREA for more information about the NEW switch.\n";
}


void help_listareas()
{
  cout << "PIPBASE LISTAREAS [VERBOSE]\n\n";
  cout << "To see the area list.\n\n";
  cout << "Add the VERBOSE switch to know all about an area, and not only the number and \n";
  cout << "the description.\n";
}


void help_listcfg()
{
  cout << "PIPBASE LISTCFG\n\n";
  cout << "To know some general settings established by SETINBOUND, SETOUTBOUND,\n";
  cout << "SETATTACHES, SETPACKER, etc. (see all SETxxxxx and RESETxxxxx commands).\n";
}


void help_listexport()
{
  cout << "PIPBASE LISTEXPORT\n\n";
  cout << "To know where each area is exported. The list is in an AREAS.BBS-like format:\n";
  cout << "area number, spaces, area tag, spaces, addresses of friends linked to the\n";
  cout << "area, newline.\n\n";
  cout << "See also EXPORT, SETEXPORT and SETFRIEND\n";
}


void help_listfriends()
{
  cout << "PIPBASE LISTFRIENDS\n\n";
  cout << "It lists all friend nodes set with SETFRIEND (see).\n";
}


void help_listorigins()
{
  cout << "PIPBASE LISTORIGINS\n\n";
  cout << "It lists all defined origins, set by SETORIGIN (see).\n";
}


void help_listroute()
{
  cout << "PIPBASE LISTROUTE\n\n";
  cout << "This command lists all routing rules defined with ADDROUTE (see).\n";
}


void help_listusers()
{
  cout << "PIPBASE LISTUSERS\n\n";
  cout << "This command prints the list of first eight users of the system, those -\n";
  cout << "defined by SETUSER (see) - accessing the PipBase from the console.\n";
}


void help_lock()
{
  cout << "PIPBASE LOCK area# message#\n\n";
  cout << "It is used to \"lock\" a message, i.e.: to prevent it to be deleted by PURGE\n";
  cout << "(see).\n\n";
  cout << "Usually, it's useful for posting policies as the first messages of an area and\n";
  cout << "make them undeletable so that users will never say \"I didn't know the \n";
  cout << "rules...\"\n\n";
  cout << "See also DELETE, PURGE and UNLOCK\n";
}


void help_manual()
{
  cout << "PIPBASE MANUAL\n\n";
  cout << "If you want to have the printed manual of PipBase, listing ordinately all\n";
  cout << "commands, type PipBase Manual >Prn: (be sure of having the printer on line!)\n";
}


void help_mark()
{
  cout << "PIPBASE MARK area# message#\n\n";
  cout << "It marks as \"received\" the specified message, i.e. it will no longer be\n";
  cout << "shown by PIPBASE READAREA ... NEW (see)\n";
}


void help_movearea()
{
  cout << "PIPBASE MOVEAREA old_area# new_area#\n\n";
  cout << "To change number to an area, you may use this command.\n";
}


void help_pack()
{
  cout << "PIPBASE PACK [area#]\n\n";
  cout << "It definitively removes deleted messages from the disk.\n";
  cout << "Usually, it's executed periodically, to avoid message base growth over its\n";
  cout << "limits (i.e. 32768 messages per area, or less if you haven't a very large\n";
  cout << "hard disk; Warning: I'm not responsible for what will happen if you axceed\n";
  cout << "that limit!).\n\n";
  cout << "If you don't specify the area#, all areas will be packed.\n\n";
  cout << "It also renumbers the messages, re-establishing a continuous numbering,\n";
  cout << "and relinks it (see LINK).\n\n";
  cout << "See also DELETE, PURGE and UNDELETE.\n";
}


void help_pickorigin()
{
  cout << "PIPBASE PICKORIGIN area# origin#\n\n";
  cout << "After you defined all your origins with SETORIGIN (see), you must associate\n";
  cout << "them to respective areas.\n";
  cout << "PICKORIGIN states that area number area# will have origin number origin#;\n";
  cout << "more than one area can have the same origin (of course, because you can have\n";
  cout << "up to 32768 areas and only up to 256 origins); if you change an origin with\n";
  cout << "SETORIGIN, it will be modified for all areas.\n\n";
  cout << "Origins defined for each area are shown with LISTAREAS VERBOSE (see); the\n";
  cout << "origin list is shown by LISTORIGINS (see).\n";
}


void help_post()
{
  cout << "PIPBASE POST area# filename.ext \"from...\"|user# \"to...\"|user# \"subject\"\n";
  cout << "   [zone net node point [PRIVATE] [HOLD|CRASH] [ATTACH|REQUEST] [KILL] [RR]\n";
  cout << "    [AUDIT]]\n\n";
  cout << "This complex command is necessary to send a message, i.e. to put it into the\n";
  cout << "PipBase.\n";
  cout << "First the message text has to be edited and placed in file filename.ext; you\n";
  cout << "may do this with any plain text editor.\n";
  cout << "Then, issue the command: area# is necessary, and is the number of the area\n";
  cout << "where the message will go; \"from...\" is the sender's name (enclose it in\n";
  cout << "quotes), but if he/she's included in the user list set by SETUSER (see), you\n";
  cout << "may specify only his user number instead of the name; similarly, \"to...\" is\n";
  cout << "the name of the recipient of the message.\n";
  cout << "If you're sending a normal message, \"subject\" is a line describing contents\n";
  cout << "of your test; for a fileattach or a file request, you'll know all later.\n";
  cout << "If choosen area is a #NETMAIL or matrix area (see CREATE), you'll have to\n";
  cout << "specify also the recipient's address with the four numbers zone, net, node and\n";
  cout << "point, and you'll may specify one or more of the following flags:\n";
  cout << "PRIVATE: it means that the message is private, and cannot be read by other\n";
  cout << "peoples (notiche that the sysop can always inspect every messages).\n";
  cout << "HOLD means that the message (or file) will be held by your system until the\n";
  cout << "addressee's system will not call; CRASH is the opposite, and means that the\n";
  cout << "message will be delivered as soon as possible by your system, calling directly\n";
  cout << "the addressee's node; if you don't specify neither CRASH nor HOLD, the\n";
  cout << "message will be treated as defined by ADDROUTE, DELROUTE and LISTROUTE (see).\n";
  cout << "ATTACH: when ATTACH is used, you must place in the subject not a simple line\n";
  cout << "of text, but a file name (complete with path): it means that the specified\n";
  cout << "file will be sent along with the message; REQUEST is its opposite: it requires\n";
  cout << "a file name as subject, but without path, and the result is that the specified\n";
  cout << "file will be requested to the remote system. file ATTACHes and REQUESTs are\n";
  cout << "never routed.\n";
  cout << "KILL simply means that the message will be killed immediately after sending.\n";
  cout << "RR is the Return Receipt Request. When it will arrive, if the addressee has a\n";
  cout << "return receipt processor such as PipBase (registered), you'll have a receipt\n";
  cout << "confirming the arrival. Some mailers follow a new standard: to request a\n";
  cout << "return receipt you must place a *RR* string in the subject (it is case-\n";
  cout << "sensitive, and you've to put the asterisks). If you do not know the standard\n";
  cout << "followed by remote's mailer, use both *RR* and RR.\n";
  cout << "AUDIT is an audit request. Sincerely, I don't know what it means, but it is on\n";
  cout << "FTS-0001\n";
}


void help_purge()
{
  cout << "PIPBASE PURGE [area#] [NOINDEX]\n\n";
  cout << "It deletes old or received messages from the message base, accordingly to the\n";
  cout << "settings established with PIPBASE CREATE (see) and shown by PIPBASE LISTAREAS\n";
  cout << "VERBOSE (see).\n\n";
  cout << "You may prevent the deletion of some messages by using the PIPBASE LOCK option\n";
  cout << "(see).\n\n";
  cout << "If you don't specify the area#, all areas will be purged.\n\n";
  cout << "If you specify NOINDEX, the DestPtr.Pip index will not be rebuilt. It means\n";
  cout << "that a user will find with SCANX also purged messages.\n";
  cout << "NOINDEX is useful when PURGE is immediately followed by an INDEX or by a PACK,\n";
  cout << "that rebuilds the DestPtr index, to speed up operations.\n\n";
  cout << "See also DELETE, LOCK, SCANX, SETPURGE, PACK and UNDELETE.\n";
}


void help_read()
{
  cout << "PIPBASE READ area# message# [MARK|DELETE]\n\n";
  cout << "It presents the message number msg# of the area number area#.\n\n";
  cout << "Area numbers are set with PIPBASE CREATE (see) and shown with PIPBASE\n";
  cout << "LISTAREAS (see).\n\n";
  cout << "In each area, messages are numbered from 0 to 32767.\n\n";
  cout << "If you specify also MARK or DELETE, a PIPBASE MARK (or DELETE) will be\n";
  cout << "performed on the emssage immediately after the reading\n\n";
  cout << "See also DELETE, UNDELETE, MARK and UNMARK.\n";
}


void help_readarea()
{
  cout << "PIPBASE READAREA area# [NEW] [MARK|DELETE]\n\n";
  cout << "This command prints on the screen all messages contained in area area# or,\n";
  cout << "if NEW is specified, all messages not yet marked as received (it doesn't use\n";
  cout << "\"lastread\" facility) or deleted.\n\n";
  cout << "The switck MARK tells to mark as received all messages printed; DELETE tells to\n";
  cout << "PIPBASE to delete them.\n\n";
  cout << "To stop scrolling, use the Pause or the Ctrl-S key of your keyboard.\n\n";
  cout << "See also: SETLASTREAD, SHOWLASTREAD and READ\n";
}


void help_resetelim4d()
{
  cout << "PIPBASE RESETELIM4D\n\n";
  cout << "This command revokes the effect of SETELIM4D (see).\n\n";
}


void help_resetexport()
{
  cout << "PIPBASE RESETEXPORT area# friend#\n\n";
  cout << "This command eliminates the specified friend form the export list of that\n";
  cout << "area, i.e.: it unlinks the node from the conference.\n\n";
  cout << "It does not delete messages yet packed (exported) but still in outbound\n";
  cout << "directory.\n\n";
  cout << "See also SETEXPORT and LISTEXPORT.\n";
}


void help_resetrobot()
{
  cout << "PIPBASE RESETROBOT KILLREQUESTS|KILLANSWERS\n\n";
  cout << "This command revokes settings established with PIPBASE SETROBOT (see it for\n";
  cout << "more informations.\n";
}


void help_rr()
{
  cout << "PIPBASE RR\n\n";
  cout << "This robot, enabled only in registered version, scans #NETMAIL area for\n";
  cout << "messages flagged with the ReturnReceiptRequest flag (see PIPBASE POST with\n";
  cout << "parameter RR) or containing the string *RR* in the subject and sends a message\n";
  cout << "(a \"return receipt\") confirming to the sender that his/her message is\n";
  cout << "arrived.\n\n";
  cout << "In addition to the standard receipt text, you may set a file (with SETRR) to\n";
  cout << "be appended to the receipt message.\n\n";
  cout << "See also GHOST, SETRR and SETGHOST.\n";
}


void help_scanx()
{
  cout << "PIPBASE SCANX user# [area#]\n\n";
  cout << "Scanx search all message base for messages addressed to the user number\n";
  cout << "user#, and displays them (if found) on the screen.\n";
  cout << "If the optional parameter area# is specified, then the search will be limited\n";
  cout << "to that area.\n";
}


void help_set()
{
  cout << "PIPBASE SET pipbase_dir logfile_name TINY|SMALL|MEDIUM|LARGE|EXTRA_LARGE\n\n";
  cout << "This is the first configuration command you've to issue. It prepares the\n";
  cout << "message base.\n\n";
  cout << "pipbase_dir is the directory where you want to store the message base\n";
  cout << "logfile_name is the name of the file where all PipBase operations will be\n";
  cout << "  logged; usually it's PB.LOG; insert NUL if you don't want any log\n";
  cout << "Last keyword is the desired model, or the size of the message base:\n";
  cout << "  TINY means 64 message areas, SMALL 256, MEDIUM 1024, LARGE 4096 and\n";
  cout << "  EXTRA-LARGE 32768.\n";
  cout << "Choose the size accordingly to your needs and the capacity of your disk.\n\n";
  cout << "See also SETPIPDIR and SETLOGFILE\n";
}


void help_setarealevel()
{
  cout << "PIPBASE SETAREALEVEL area# level#\n\n";
  cout << "You may assign a level to every area; level# is a number between 0 and 255 and\n";
  cout << "is used to protect indiscriminated access to some areas.\n\n";
  cout << "By default, the level of a nre created area is 0, i.e. all users can read,\n";
  cout << "write and areafix it.\n";
  cout << "See also SETAREAFIX.\n";
}


void help_setareafix()
{
  cout << "PIPBASE SETAREAFIX friend# password level#\n\n";
  cout << "This command enables friend number friend# to making requests to AreaFix (see\n";
  cout << "PIPBASE AREAFIX) with password \"password\".\n\n";
  cout << "To the friend is associated a level, level#, between 0 and 255; you may\n";
  cout << "prevent the friend to link some areas by setting the friend level lower than\n";
  cout << "the area level.\n\n";
  cout << "Area levels are set with SETAREALEVEL (see).\n";
}


void help_setattaches()
{
  cout << "PIPBASE SETATTACHES netmail_directory PIP!|FRODO|D'B|BINK|TRAPDOOR\n";
  cout << "  [PACK[-MATRIX]|DYNA[MIC-PACKING]]\n\n";
  cout << "you must inform PipBase on how it has to communicate with the front end, i.e.\n";
  cout << "with the program that handles modem connections.\n";
  cout << "netmail_directory is the directory where your front end holds matrix messages,\n";
  cout << "fileattaches and filerequests.\n";
  cout << "PIP! specifies that you use Pip! front-end, the best choice; in this case,\n";
  cout << "netmail_directory is only a temporary directory.\n";
  cout << "FRODO and D'B specify that your mailer uses netmail messages to carry\n";
  cout << "fileattaches; in this case, do NOT delete strange netmail messages.\n";
  cout << "Most famous programs using this fileattach style are Front Door and D'Bridge.\n";
  cout << "BINK and TRAPDOOR are to use PipBase with *.FLO fileattaches, as Binkley Term\n";
  cout << "and Trap Door do.\n";
  cout << "Optionally, you may specify if matrix messages have to be packed by PipBase\n";
  cout << "[PACK-MATRIX] or left to the front end [DYNAMIC-PACKING]. For D'Bridge and\n";
  cout << "Front Door it's indifferent; Pip! needs PACK-MATRIX; for BINK and TRAPDOOR ,\n";
  cout << "you may specify PACK-MATRIX (better) but also DYNAMIC-PACKING and then use\n";
  cout << "an external program such as Qmail or Ommm to route messages.\n";
  cout << "If you leave DYNAMIC-ROUTING, you don't need to define a route with ADDROUTE.\n";
}


void help_setelim4d()
{
  cout << "PIPBASE SETELIM4D\n\n";
  cout << "Some old (like Qmail) or buggy mailers don't accept 4-dimensional informations\n";
  cout << "in SEEN-BYes and PATHs; with PIPBASE SETELIM4D, you tell to PipBase to hide\n";
  cout << "4D informations and leave only 3D standard addresses.\n\n";
  cout << "This parameter is not used when a fakenet is used.\n\n";
  cout << "If you're a point, do NOT set this, or you'll see all your messages doubled!\n";
  cout << "If you're a boss node, set this accordingly to your up/down links (use PIPBASE\n";
  cout << "SETELIM4D if you're surrounded by old-style 3D processors, PIPBASE RESETELIM4D\n";
  cout << "if they all have new packers.\n\n";
  cout << "See also RESETELIM4D\n";
}


void help_setexport()
{
  cout << "PIPBASE SETEXPORT area# friend#\n";
  cout << "\n";
  cout << "This command tells PipBase to export an echomail area to a friend, i.e. to \n";
  cout << "send him copies of all messages written in that area or arriving from other \n";
  cout << "nodes.\n";
  cout << "\n";
  cout << "It's valid only in \"echomail\" areas (also known as conferences).\n";
  cout << "\n";
  cout << "Notice that only new messages (not also the messages yet written) will be \n";
  cout << "sent, and that they're sent only when you perform a PIPBASE EXPORT.\n";
  cout << "\n";
  cout << "See also RESETEXPORT, CREATE, EXPORT, LISTEXPORT and SETFRIEND.\n";
}


void help_setfake()
{
  cout << "PIPBASE SETFAKE fakenet#\n\n";
  cout << "If you're a point, your boss will explain you the use of the so-called fakenet\n";
  cout << "(or fake-address); so, probably, it will be bored of using this antiquate\n";
  cout << "method for addressing points.\n";
  cout << "If you're a boss system, why to use fakenet? Full 4-dimensional addressing\n";
  cout << "is better! In some regions, there are rules to establish the fakenet, so, if\n";
  cout << "you cannot do a better choice (problems with old points), ask your network\n";
  cout << "coordinator.\n\n";
  cout << "If you don't specify a SETFAKE, 4D-addressing will be used; to stop 3D-\n";
  cout << "operations and return to 4D after a SETFAKE, type PIPBASE SETFAKE 0.\n";
}


void help_setfriend()
{
  cout << "PIPBASE SETFRIEND friend# zone# net# node# point# packer parameters [HOLD|CRASH]\n";
  cout << "\n";
  cout << "This informs the PipBase system that a node is your \"friend\" i.e. that you \n";
  cout << "regularly exchange mail with it.\n";
  cout << "You need to define with SETFRIEND all nodes you export echomail to, and all \n";
  cout << "nodes you route netmail via.\n";
  cout << "\n";
  cout << "friend# is a progressive number from 0 to 255.\n";
  cout << "zone#, net#, node# and point# are the network address of the node: contact the\n";
  cout << "  network administrator (if you're a BBS) or your boss (if you're a point) if\n";
  cout << "  in doubt.\n";
  cout << "packer is the name of your favourite packer, like PkZip, Arj, LhArc, etc. Be \n";
  cout << "  sure that the node you send mail to supports that packer (It has to support \n";
  cout << "  Arc, and so specify it if in doubt. Contact the system operator to know if \n";
  cout << "  he admits something better). You've to specify the extension .COM or .EXE.\n";
  cout << "parameters are passed to the pacher before the name of the archive name. \n";
  cout << "  Enclose them in doble quotes if they're more than one. They depend from \n";
  cout << "  packer. by example:\n";
  cout << "  PkZip.Exe -eax            LhArc.Exe \"a -m\"           PkPak.Exe -a\n";
  cout << "The HOLD switch specifies that you'll never call that node: you'll wait his \n";
  cout << "call to send him his mail; CRASH means that mail for the friend will be sent\n";
  cout << "immediatly when packed\n";
  cout << "\n";
  cout << "See also SETEXPORT and ADDROUTE.\n";
}


void help_setghost()
{
  cout << "PIPBASE SETGHOST \"Ghostwriter's name\"\n";
  cout << "When the Ghostwriter, invoked by RR or GHOST, sends a receipt message, it\n";
  cout << "usually signs as \"PipBase GhostWriter\". If you want to made him signing\n";
  cout << "with another name, like \"Pasquini's Ghostwriter\" (Stefano Pasquini, REC\n";
  cout << "REC 2:33, is famous for his ghostwriter - \"The spirit of italian fidonet\"),\n";
  cout << "You may set another name using this function.\n\n";
  cout << "See also RR and GHOST\n";
}


void help_setinbound()
{
  cout << "PIPBASE SETINBOUND directory_name\n";
  cout << "\n";
  cout << "This command is to set your inbound file directory, i.e. the directory where \n";
  cout << "your mailer puts files just received from another node.\n";
  cout << "\n";
  cout << "Front Door and D'Bridge aficionados call it \"File\" directory, Opus-dependent \n";
  cout << "people call it \"Inbound\" directory and Binkley Term lovers use the term \"Mail \n";
  cout << "File\" directory as well as \"Inbound\". Dont' get confused and set it \n";
  cout << "identically as it is in your mailer setup! (obviously, if you use PIP! as \n";
  cout << "mailer, you haven't to set it twice).\n";
  cout << "\n";
  cout << "See also SETINBOUND, SETATTACHES and LISTCFG.\n";
}


void help_setlastread()
{
  cout << "PIPBASE SETLASTREAD user# area# message#\n\n";
  cout << "Each user has a bookmark, called the \"lastread pointer\", for each area.\n";
  cout << "With SETLASTREAD, the user number user# may move his lastread pointer in the\n";
  cout << "desired area to the desired message.\n\n";
  cout << "See also SHOWLASTREAD\n";
}


void help_setlogfile()
{
  cout << "PIPBASE SETLOGFILE filename.ext\n\n";
  cout << "This overrides the log file name defined with PIPBASE SET (see).\n";
  cout << "You may also specify a full path name, with directory.\n";
}


void help_setloglevel()
{
  cout << "PIPBASE SETLOGLEVEL 0|1|2|3\n\n";
  cout << "You may want a less or more detailed log file.\n";
  cout << "To have a very detailed log file, specify a 3; for a shorter log, specify 0\n";
  cout << "1 and 2 are intermediate solutions.\n\n";
  cout << "See SET to know what the log file is.\n";
}


void help_setlogtype()
{
  cout << "PIPBASE SETLOGTYPE 0|1\n\n";
  cout << "There are two styles in writing the log file: 0 for a Binkley/Opus style and\n";
  cout << "1 for Front Door/D'Bridge style.\n";
  cout << "The former is more linear; the latter is more compact.\n\n";
  cout << "Since de gustibus non est disputandum, try both and then make your choice.\n";
}


void help_setnode()
{
  cout << "PIPBASE SETNODE aka#|0 zone# net# node# point# domain\n\n";
  cout << "If you're in a network, you must have an address (or more than one).\n";
  cout << "PipBase allows up to ten different addresses, numbered from 0 to 9.\n";
  cout << "Address #0 is the main address.\n\n";
  cout << "An address is composed by four numbers: zone# net# node# and point#, and a\n";
  cout << "string, called domain. Usually they're printed in the \"fidonet\" format\n";
  cout << "zone:net/node.point@domain. When point is 0, it's often omitted.\n";
  cout << "Addresses are assigned by the network coordinator (or by the boss if you're\n";
  cout << "a simple point): ask him!\n\n";
  cout << "aka# is the number of the address you're specifying. Other parameters are the\n";
  cout << "fields of the address\n\n";
  cout << "See also SETFAKE and LISTAKAS\n";
}


void help_setorigin()
{
  cout << "PIPBASE SETORIGIN origin# \"origin text\"\n\n";
  cout << "On every echomail message, near the end, there is a sort of banner, stating\n";
  cout << "where the message comes from, called the \"origin\".\n";
  cout << "Each sysop, or point, has his origin. You may change frequently origin, and\n";
  cout << "have different origins for different areas.\n\n";
  cout << "With PipBase, you must define an origin list, from which you'll choose the\n";
  cout << "origin to be associated to an area. This function is performed by SETORIGIN.\n";
  cout << "origin# is the number of the entry in the origin table, from 0 to 255;\n";
  cout << "LISTORIGINS, PICKORIGIN and CREATE will refer to this code.\n";
  cout << "origin text (remember to enclose it in double quotes) is the text of the\n";
  cout << "banner, not including the fixed prefix \" * Origin: \" and your address (that\n";
  cout << "will be added by default at the end of the origin text.\n\n";
  cout << "Usually, an origin is one of the most powerful ways to manifest a point's\n";
  cout << "creativity\n";
}


void help_setoutbound()
{
  cout << "PIPBASE SETOUTBOUND directory_name\n";
  cout << "\n";
  cout << "This command is to set your outbound file directory, i.e. where the outgoing \n";
  cout << "mail is stored, waiting to be sent.\n";
  cout << "\n";
  cout << "Set it as it is in your mailer setup. Notice that some mailers double it as \n";
  cout << "\"Outbound\" directory and as \"ArcMail\" directory.\n";
  cout << "\n";
  cout << "See also SETINBOUND, SETATTACHES and LISTCFG.\n";
}


void help_setpacker()
{
  cout << "PIPBASE SETPACKER packer.ext \"parameters\"\n\n";
  cout << "This command sets your default mail packer and the parameters to run it.\n";
  cout << "Since all nodes must be able to unpack mail compressed with the default packer,\n";
  cout << "it's usually set to an .ARC-compatible packer, such as ARC or PKPAK.\n\n";
  cout << "You must specify proper .COM or .EXE extension too, and parameters to be\n";
  cout << "passed for right operations.\n\n";
  cout << "See also SETFRIEND\n";
}


void help_setpackerdir()
{
  cout << "PIPBASE SETPACKERDIR drive:\packer_directory\n\n";
  cout << "Unless you've all your file packers and all respective unpackers in a directory\n";
  cout << "pointd by the PATH environnement variable, you must declare here with\n";
  cout << "SetPackerDir where they can be found.\n\n";
  cout << "Packers supported are PkPak, PkUnPak, PkArc, PkXarc, Pak, Arj, Zoo, LhArc, LhA,\n";
  cout << "PkZip and PkUnZip.\n";
}


void help_setpipdir()
{
  cout << "PIPBASE SETPIPDIR pipbase_directory\n\n";
  cout << "If you want to move all your message base from one directory to another, you\n";
  cout << "must also inform PipBase of that, using the SETPIPDIR command to tell what is\n";
  cout << "the name of the new directory (eventually complete with drive specifications).\n\n";
  cout << "This command modifies the value set with PIPBASE SET (see), but does NOT move\n";
  cout << "files from a directory to another: you must do that manually.\n";
}


void help_setpurge()
{
  cout << "PIPBASE SETPURGE area# messages# days#\n\n";
  cout << "When you CREATEd area number area#, you specified some criteria for deleting\n";
  cout << "old messages; with SETPURGE you may modify them.\n";
  cout << "area# is the number of the area you want to modify; other parameters are\n";
  cout << "discussed in CREATE and PURGE sections (see).\n";
}


void help_setrobot()
{
  cout << "PIPBASE SETROBOT KILLREQUESTS|KILLANSWERS\n\n";
  cout << "Pipbase has some robots in it. Robots are procedures that execute commands when\n";
  cout << "a #NETMAIL message is addressed to them, and they may answer with a message.\n";
  cout << "You may keep all messages directed to, and coming from, robots, or let robots\n";
  cout << "delete them when processed.\n";
  cout << "By default, they aren't killed; if you issue PIPBASE SETROBOT KILLREQUESTS,\n";
  cout << "all messages from users to robots will be killed; if the parameter passed is\n";
  cout << "KILLANSWERS, all messages written by robots will be flagged as KILL/SENT (see\n";
  cout << "PIPBASE POST).\n";
  cout << "To return to keeping track of messages, you'll have to issue a PIPBASE\n";
  cout << "RESETROBOT (see).\n";
  cout << "Robot settings are shown by LISTCFG (see).\n";
}


void help_setrr()
{
  cout << "PIPBASE SETRR return_receipt_file|NULL\n\n";
  cout << "This specifies the file to be used to send the return receipt with PIPBASE RR\n";
  cout << "(see).\n";
  cout << "It is not necessary, because there's a standard message. If you specify it,\n";
  cout << "it will be appended to the standard text.\n\n";
  cout << "return_receipt_file is the name (complete with path and extension) of an\n";
  cout << "existing plain ASCII file.\n";
  cout << "To return to the standard message, simply type PIPBASE SETRR NULL\n";
}


void help_settag()
{
  cout << "PIPBASE SETTAG area# tagname\n\n";
  cout << "If you want to change the echotag to an area, use this.\n";
  cout << "area# is the number of the area you want to change; tagname is the new tag.\n\n";
  cout << "If you specify #NETMAIL or #LOCAL for tagname, the area will not still be an\n";
  cout << "echomail area.\n\n";
  cout << "A tag change does not affect SETEXPORT values.\n\n";
  cout << "See also LISTEXPORT, CREATE, SETEXPORT and EXPORT\n";
}


void help_settear()
{
  cout << "PIPBASE SETTEAR \"tearline text\"\n\n";
  cout << "The tearline is a line added to every echomail message, near the end,\n";
  cout << "preceeded by three minus sign ('-'), to tell to the world that you use a\n";
  cout << "certain program.\n\n";
  cout << "PipBase's tearline always contains the name PipBase, the version number and\n";
  cout << "your registration number (or the \"demo\" string if you're unregistered; see\n";
  cout << "BOOST for explanations), but you may add the name of another product, such as\n";
  cout << "PipReply, or the name of an utility of yours (to do a little commercial spot).\n";
  cout << "Simply specify the string you want to add between double quotes, like\n";
  cout << "PIPBASE SETTEAR \"+ VVreply 0.99\"\n";
}


void help_settempdir()
{
  cout << "PIPBASE SETTEMPDIR temporary_directory\n\n";
  cout << "PipBase needs sometimes to write on disk lots of datas, to delete them a few\n\n";
  cout << "instants later.\n";
  cout << "With SetTempDir you specify where to store these temporary datas.\n";
  cout << "I suggest to place this directory on your fastest device, but be sure that,\n";
  cout << "especially for RAM disks, there's enought space (some hundreds of Kb are a\n";
  cout << "large device for a point; at least a megabyte is needed for a BBS, and more\n";
  cout << "than one if it has a lot of points or it's a hub or host.\n";
}


void help_setunpacker()
{
  cout << "PIPBASE SETUNPACKER jolly_unpacker_program \"parameters\"\n\n";
  cout << "This command sets the useful \"Jolly unpacker\", an unpacking program to use\n";
  cout << "when PIPBASE does not recognize the packer that created the incoming bundle.\n\n";
  cout << "Parameters are the same as for PIPBASE SETPACKER (see).\n\n";
  cout << "You may place here a general unpacking program like GUS, or any new unpacker,\n";
  cout << "other than PkUnZip, PkXArc, Arj, Lha and Pak, like XArcPlus, that you know\n";
  cout << "your feeder is using.\n";
}


void help_setuser()
{
  cout << "PIPBASE SETUSER user# \"user name\"|NULL\n\n";
  cout << "PipBase needs an internal user list of the system operators, i.e. of those\n";
  cout << "users accessing the message base directly via PipBase.Exe.\n";
  cout << "These users are numbered from 0 to 7, and you set each of them with a SETUSER\n";
  cout << "command; the list is shown by LISTUSERS (see).\n\n";
  cout << "Be aware that the user # 0 has to be the legal sysop, whose name is on the\n";
  cout << "registration key.\n\n";
  cout << "To remove an user from list, use PIPBASE SETUSER n NULL\n";
}


void help_setuucp()
{
  cout << "PIPBASE SETUUCP outbound_zone net node inbound_zone net node\n\n";
  cout << "PipBase and PipReply can transparently handle internet messages, using the\n";
  cout << "UUCP gateways.\n\n";
  cout << "This is not the proper site for a complete tractation of internet messages,\n";
  cout << "but if you want to use them, let PipBase know the IFNA-style addresses of the\n";
  cout << "outbound (i.e.: IFNA style network -> UUCP) and inbound gateway (UUCP -> IFNA).\n\n";
  cout << "IFNA addresses are of the form zone:net/node.\n\n";
  cout << "To know these addresses, ask the gateway administrator (for zone 2, Cesare\n";
  cout << "Dieni, 2:332/600 fidonet or cesare@wolf.sublink.org internet, or an internet\n";
  cout << "guide.\n\n";
  cout << "Warning: DO NOT TOUCH THIS COMMAND UNLESS YOU KNOW WHAT YOU'RE DOING!\n";
}


void help_showlastread()
{
  cout << "PIPBASE SHOWLASTREAD user# area#\n\n";
  cout << "This command displays where user number user# placed his bookmark in area\n";
  cout << "area# (remember that an user has as a bookmark in every area...)\n\n";
  cout << "See also SETLASTREAD\n";
}


void help_stat()
{
  cout << "PIPBASE STAT\n\n";
  cout << "Stat provides some stathistics on the message base, simply displayed.\n";
}


void help_undelete()
{
  cout << "PIPBASE UNDELETE area# message#\n";
  cout << "\n";
  cout << "It recovers message number message# from area area#, where it was accidentally \n";
  cout << "deleted.\n";
  cout << "\n";
  cout << "After a PIPBASE PACK (see), you'll never recover any message.\n";
  cout << "\n";
  cout << "See also PIPBASE DELETE.\n";
}


void help_unlock()
{
  cout << "PIPBASE UNLOCK area# message#\n";
  cout << "\n";
  cout << "This command revocates the locking established by PIPBASE LOCK. After its \n";
  cout << "execution, purge will be able to delete the message.\n";
}


void help_unmark()
{
  cout << "PIPBASE UNMARK area# message#\n";
  cout << "\n";
  cout << "To reset the \"received\" flag from the specified message.\n";
  cout << "\n";
  cout << "See also MARK\n";
}


void general_help()
{
  cout << "\nPIPBASE is a collection of basic procedures to manage PIPBase messages.\n";
  cout << "By Roberto Piola - Italy - 1991 - SUPPORT PIPBASE PROJECT!\n";
  cout << "Syntax is: PIPBASE <command> [parameters...]\n";
  cout << "Commands and parameters are:\n";
  cout << "ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]\n";
  cout << "AREAFIX\n";
  cout << "CREATE area# \"description\" tagname|#LOCAL|#NETMAIL|#BAD|#DUPES message# day# [origin#]\n";
  cout << "DELETE area# message#\n";
  cout << "DELROUTE rule#\n";
  cout << "DESTROY area#\n";
  cout << "EXPORT\n";
  cout << "GHOST\n";
  cout << "HELP [specific_command]\n";
  cout << "IMPORT\n";
  cout << "INDEX [area#]\n";
  cout << "INFO\n";
  cout << "LINK [area#]\n";
  cout << "LISTAKAS\n";
  cout << "LISTAREA area# [NEW]\n";
  cout << "LISTAREAS [VERBOSE]\n";
  cout << "LISTCFG\n";
  cout << "LISTEXPORT\n";
  cout << "LISTFRIENDS\n";
  cout << "LISTORIGINS\n";
  cout << "LISTROUTE\n";
  cout << "LISTUSERS\n";
  cout << "LOCK area# message#\n";
  cout << "MARK area# message#\n";
  cout << "MOVEAREA oldarea# newarea#\n";
  cout << "PACK [area#]\n";
  cout << "PICKORIGIN area# origin#\n";
  cout << "POST area# filename.ext \"from...\"|user# \"to...\"|user# \"subject\" [zone net node point [PRIVATE [HOLD|CRASH] [ATTACH|REQUEST] [KILL] [RR] [AUDIT]]\n";
  cout << "PURGE [area#]\n";
  cout << "READ area# message# [MARK]\n";
  cout << "READAREA area# [NEW] [MARK]\n";
  cout << "RESETELIM4D\n";
  cout << "RESETEXPORT area# friend#\n";
  cout << "RESETROBOT KILLREQUESTS|KILLANSWERS\n";
  cout << "RR\n";
  cout << "SCANX user# [area#]\n";
  cout << "SET pipbase_directory logfile_name TINY|SMALL|MEDIUM|LARGE|EXTRA-LARGE\n";
  cout << "SETAREALEVEL area# level#\n";
  cout << "SETAREAFIX friend# password level#\n";
  cout << "SETATTACHES netmail_*.msg_directory PIP!|FRODO|D'B|BINK|TRAPDOOR [PACK-MATRIX|DYNAMIC-PACKING]\n";
  cout << "SETELIM4D\n";
  cout << "SETEXPORT area# friend#\n";
  cout << "SETFAKE fakenet#\n";
  cout << "SETFRIEND friend# zone# net# node# point# packer \"packer_parameters\"\n";
  cout << "SETGHOST \"Gostwriter's name\"\n";
  cout << "SETINBOUND inbound_directory\n";
  cout << "SETLASTREAD user# area# message#\n";
  cout << "SETLOGFILE filename\n";
  cout << "SETLOGLEVEL 0|1|2|3\n";
  cout << "SETLOGTYPE 0|1\n";
  cout << "SETNODE aka#|0 zone# net# node# point# domain\n";
  cout << "SETORIGIN origin# \"origin text\"\n";
  cout << "SETOUTBOUND outbound_directory\n";
  cout << "SETPACKER packer_program.ext \"parameters\"\n";
  cout << "SETPACKERDIR packer_directory\n";
  cout << "SETPIPDIR pipbase_directory\n";
  cout << "SETPURGE area# messages# days#\n";
  cout << "SETROBOT KILLREQUESTS|KILLANSWERS\n";
  cout << "SETRR return_receipt_file\n";
  cout << "SETTAG area# tag\n";
  cout << "SETTEAR \"your tearline\"\n";
  cout << "SETTEMPDIR temporary_directory\n";
  cout << "SETUNPACKER jolly_unpacker_program_name \"parameters\"\n";
  cout << "SETUSER user# \"user name\"\n";
  cout << "SETUUCP outbound_zone net node inbound_zone net node\n";
  cout << "SHOWLASTREAD user# area#\n";
  cout << "STAT\n";
  cout << "UNDELETE area# message#\n";
  cout << "UNLOCK area# message#\n";
  cout << "UNMARK area# message#\n";
}


void printinfo()
{
  printf("This is version %d.%02d\n\n",PIPBASEVERSION,PIPBASESUBVERSION);
  cout << "This GREAT new messagebase format was invented in Italy, in 1990/'91, by\n\n";
  cout << "Roberto Piola and Elio Fenoglio.\n";
  cout << "\nThe source code for basic Pipbase management procedures is in P.D., as well\n";
  cout << "as the documentation about the format.\n";
  cout << "\nFor more info, please contact the authors:\n";
  cout << "\nRoberto Piola                              Elio Fenoglio\n";
  cout << "via D.Godino, 8/C                          v.Brigata Cagliari, 27\n";
  cout << "10060 S.Secondo di Pinerolo (TO)           10060 Pinerolo (TO)\n";
  cout << "ITALY                                      ITALY\n";
  cout << "tel.:+39-121-500663 (BBS by night!)        tel.:+39-121-396548\n"; 
  cout << "fidonet: 2:334/306.1                       fidonet: 2:334/306.4\n";
  cout << "internet: roberto@p1.f306.n334.z2.fidonet.org\n";
  cout << "                        internet: elio@p4.f306.n334.z2.fidonet.org\n";
  cout << "UUCP:...!gear!wolf!334!306.1!roberto       ...!gear!wolf!334!306.4!elio\n";
  cout << "\nThanks to Silvan Calarco, fidonet 2:334/100.2 for mailer procedures\n";
  cout << "\n Support PipBase!\n";
}


#define FF cout << "\n\n\n\n";

void manual()
{
  printinfo(); FF
  general_help(); FF
  help_addroute(); FF
  help_areafix(); FF
  help_boost(); FF
  help_create(); FF
  help_delete(); FF
  help_delroute(); FF
  help_destroy(); FF
  help_export(); FF
  help_ghost(); FF
  help_help(); FF
  help_index(); FF
  help_import(); FF
  help_info(); FF
  help_link(); FF
  help_listakas(); FF
  help_listarea(); FF
  help_listareas(); FF
  help_listcfg(); FF
  help_listexport(); FF
  help_listfriends(); FF
  help_listorigins(); FF
  help_listroute(); FF
  help_listusers(); FF
  help_lock(); FF
  help_manual(); FF
  help_mark(); FF
  help_movearea(); FF
  help_pack(); FF
  help_pickorigin(); FF
  help_post(); FF
  help_purge(); FF
  help_read(); FF
  help_readarea(); FF
  help_resetelim4d(); FF
  help_resetexport(); FF
  help_resetrobot(); FF
  help_rr(); FF
  help_scanx(); FF
  help_set(); FF
  help_setareafix(); FF
  help_setarealevel(); FF
  help_setattaches(); FF
  help_setelim4d(); FF
  help_setexport(); FF
  help_setfake(); FF
  help_setfriend(); FF
  help_setghost(); FF
  help_setinbound(); FF
  help_setlastread(); FF
  help_setlogfile(); FF
  help_setloglevel(); FF
  help_setlogtype(); FF
  help_setnode(); FF
  help_setorigin(); FF
  help_setoutbound(); FF
  help_setpacker(); FF
  help_setpackerdir(); FF
  help_setpipdir(); FF
  help_setpurge(); FF
  help_setrobot(); FF
  help_setrr(); FF
  help_settag(); FF
  help_settear(); FF
  help_settempdir(); FF
  help_setunpacker(); FF
  help_setuser(); FF
  help_setuucp(); FF
  help_showlastread(); FF
  help_stat(); FF
  help_undelete(); FF
  help_unlock(); FF
  help_unmark(); FF
}


void main(int argc,char *argv[])
{
  char *c;
  if(argc==2)
    {
      strupr(c=argv[1]);
      if(!strcmp(c,"!!!INFO")) {printinfo(); exit(0);}
      if(!strcmp(c,"!!!MANUAL")) {manual(); exit(0);}
      if(!strcmp(c,"ADDROUTE")) {help_addroute(); exit(0);}
      if(!strcmp(c,"AREAFIX")) {help_areafix(); exit(0);}
      if(!strcmp(c,"BOOST")) {help_boost(); exit(0);}
      if(!strcmp(c,"CREATE")) {help_create(); exit(0);}
      if(!strcmp(c,"DELETE")) {help_delete(); exit(0);}
      if(!strcmp(c,"DELROUTE")) {help_delroute(); exit(0);}
      if(!strcmp(c,"DESTROY")) {help_destroy(); exit(0);}
      if(!strcmp(c,"EXPORT")) {help_export(); exit(0);}
      if(!strcmp(c,"GHOST")) {help_ghost(); exit(0);}
      if(!strcmp(c,"HELP")) {help_help(); exit(0);}
      if(!strcmp(c,"INDEX")) {help_index(); exit(0);}
      if(!strcmp(c,"IMPORT")) {help_import(); exit(0);}
      if(!strcmp(c,"INFO")) {help_info(); exit(0);}
      if(!strcmp(c,"LINK")) {help_link(); exit(0);}
      if(!strcmp(c,"LISTAKAS")) {help_listakas(); exit(0);}
      if(!strcmp(c,"LISTAREA")) {help_listarea(); exit(0);}
      if(!strcmp(c,"LISTAREAS")) {help_listareas(); exit(0);}
      if(!strcmp(c,"LISTCFG")) {help_listcfg(); exit(0);}
      if(!strcmp(c,"LISTEXPORT")) {help_listexport(); exit(0);}
      if(!strcmp(c,"LISTFRIENDS")) {help_listfriends(); exit(0);}
      if(!strcmp(c,"LISTORIGINS")) {help_listorigins(); exit(0);}
      if(!strcmp(c,"LISTROUTE")) {help_listroute(); exit(0);}
      if(!strcmp(c,"LISTUSERS")) {help_listusers(); exit(0);}
      if(!strcmp(c,"LOCK")) {help_lock(); exit(0);}
      if(!strcmp(c,"MANUAL")) {help_manual(); exit(0);}
      if(!strcmp(c,"MARK")) {help_mark(); exit(0);}
      if(!strcmp(c,"MOVEAREA")) {help_movearea(); exit(0);}
      if(!strcmp(c,"PACK")) {help_pack(); exit(0);}
      if(!strcmp(c,"PICKORIGIN")) {help_pickorigin(); exit(0);}
      if(!strcmp(c,"POST")) {help_post(); exit(0);}
      if(!strcmp(c,"PURGE")) {help_purge(); exit(0);}
      if(!strcmp(c,"READ")) {help_read(); exit(0);}
      if(!strcmp(c,"READAREA")) {help_readarea(); exit(0);}
      if(!strcmp(c,"RESETELIM4D")) {help_resetelim4d(); exit(0);}
      if(!strcmp(c,"RESETEXPORT")) {help_resetexport(); exit(0);}
      if(!strcmp(c,"RESETROBOT")) {help_resetrobot(); exit(0);}
      if(!strcmp(c,"RR")) {help_rr(); exit(0);}
      if(!strcmp(c,"SCANX")) {help_scanx(); exit(0);}
      if(!strcmp(c,"SET")) {help_set(); exit(0);}
      if(!strcmp(c,"SETAREALEVEL")) {help_setarealevel(); exit(0);}
      if(!strcmp(c,"SETAREAFIX")) {help_areafix(); exit(0);}
      if(!strcmp(c,"SETATTACHES")) {help_setattaches(); exit(0);}
      if(!strcmp(c,"SETELIM4D")) {help_setelim4d(); exit(0);}
      if(!strcmp(c,"SETEXPORT")) {help_setexport(); exit(0);}
      if(!strcmp(c,"SETFAKE")) {help_setfake(); exit(0);}
      if(!strcmp(c,"SETFRIEND")) {help_setfriend(); exit(0);}
      if(!strcmp(c,"SETGHOST")) {help_setghost(); exit(0);}
      if(!strcmp(c,"SETINBOUND")) {help_setinbound(); exit(0);}
      if(!strcmp(c,"SETLASTREAD")) {help_setlastread(); exit(0);}
      if(!strcmp(c,"SETLOGFILE")) {help_setlogfile(); exit(0);}
      if(!strcmp(c,"SETLOGLEVEL")) {help_setloglevel(); exit(0);}
      if(!strcmp(c,"SETLOGTYPE")) {help_setlogtype(); exit(0);}
      if(!strcmp(c,"SETNODE")) {help_setnode(); exit(0);}
      if(!strcmp(c,"SETORIGIN")) {help_setorigin(); exit(0);}
      if(!strcmp(c,"SETOUTBOUND")) {help_setoutbound(); exit(0);}
      if(!strcmp(c,"SETPACKER")) {help_setpacker(); exit(0);}
      if(!strcmp(c,"SETPACKERDIR")) {help_setpackerdir(); exit(0);}
      if(!strcmp(c,"SETPIPDIR")) {help_setpipdir(); exit(0);}
      if(!strcmp(c,"SETPURGE")) {help_setpurge(); exit(0);}
      if(!strcmp(c,"SETROBOT")) {help_setrobot(); exit(0);}
      if(!strcmp(c,"SETRR")) {help_setrr(); exit(0);}
      if(!strcmp(c,"SETTAG")) {help_settag(); exit(0);}
      if(!strcmp(c,"SETTEAR")) {help_settear(); exit(0);}
      if(!strcmp(c,"SETTEMPDIR")) {help_settempdir(); exit(0);}
      if(!strcmp(c,"SETUNPACKER")) {help_setunpacker(); exit(0);}
      if(!strcmp(c,"SETUSER")) {help_setuser(); exit(0);}
      if(!strcmp(c,"SETUUCP")) {help_setuucp(); exit(0);}
      if(!strcmp(c,"SHOWLASTREAD")) {help_showlastread(); exit(0);}
      if(!strcmp(c,"STAT")) {help_stat(); exit(0);}
      if(!strcmp(c,"UNDELETE")) {help_undelete(); exit(0);}
      if(!strcmp(c,"UNLOCK")) {help_unlock(); exit(0);}
      if(!strcmp(c,"UNMARK")) {help_unmark(); exit(0);}
      cout << "I don't know this command.\nPlease run PIPBASE HELP to have the command list.\7\n"; 
      exit(1);
    }
  else
    general_help();
}
