/* Killorph.c kills orphan bundles, left by FD */

#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <ctype.h>
#include "pipbase.h"
#include "strlist.h"


isbundle(char *n)
{
  strupr(n);
  return((strstr(n,".MO") || strstr(n,".TU") ||
          strstr(n,".WE") || strstr(n,".TH") ||
          strstr(n,".FR") || strstr(n,".SA") ||
          strstr(n,".SU")) &&
         isdigit(n[strlen(n)-1]));
}


kill_orphan_bundles(char*outbound,char*netmail,int onlykill)
{
  struct ffblk blk;
  char fn[72],lbuff[120];
  stringlist*l=NULL;
  stringlist*t;
  FIDOMSG hdr;
  FILE *f;
  sprintf(fn,"%s*.*",outbound);
  if (!findfirst(fn,&blk,0))
    do
      {
        strupr(blk.ff_name);
        if(isbundle(blk.ff_name))
          {
            sprintf(fn,"%s%s",outbound,blk.ff_name);
            if(blk.ff_fsize)
              {if(!onlykill) l=cons(fn,l);}
            else
              {
                sprintf(lbuff,"Truncating 0-lenght bundle %s",fn);
                puts(lbuff); logg('>',lbuff,3);
                unlink(fn);
              }
          }
      } while(!findnext(&blk));
  if(onlykill) return 0;
  sprintf(fn,"%s*.msg",netmail);
  if(!findfirst(fn,&blk,0))
    do
      {
        sprintf(fn,"%s%s",netmail,blk.ff_name);
        f=fopen(fn,"rb");
        fread(&hdr,sizeof hdr,1,f);
        fclose(f);
        t=l;
        while(t)
          {
            if(!stricmp(car(t),hdr.subj))
              {*(car(t))=0; break;}
            t=t->next;
          }
      } while (!findnext(&blk));
  t=l;
  while(t)
    {
      if(*(car(t)))
        {
          sprintf(lbuff,"Killing orphan bundle %s",car(t));
          logg('>',lbuff,3); puts(lbuff);
          unlink(car(t));
        }
      t=cdr(t);
    }
  garbage_collect(l);
  return 1;
}
