/* Pip.C procedures to handle PIP compressed strings (type 10 messages) */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


char *pip[128]={
"PREFIX","SEEN-BY: ","MSGID: ","PATH: ",": ",
"zion","ment","---","che","chi","ghe","ghi","str","","il","al","ed",
"pr","st","..","  ",", ",". ","; ","++",
"a'","e'","i'","o'","u'","a ","e ",
"i ","o ","u ","nt","hi",
"bb","ba","be","bi","bo","bu",
"cc","ca","ce","ci","co","cu",
"dd","da","de","di","do","du",
"ff","fa","fe","fi","fo","fu",
"gg","ga","ge","gi","go","gu",
"ll","la","le","li","lo","lu",
"mm","ma","me","mi","mo","mu",
"nn","na","ne","ni","no","nu",
"pp","pa","pe","pi","po","pu",
"rr","ra","re","ri","ro","ru",
"ss","sa","se","si","so","su",
"tt","ta","te","ti","to","tu",
"vv","va","ve","vi","vo","vu",
"zz","za","ze","zi","zo","zu",
"==",":-","' ","ha","ho","qu","#"};


pipstring(unsigned char *s,FILE *f)
{
  register int best;
  char l;
  while (*s)
    {
      if (*s==10)
        s++;
      else
        {
          best=127; l=1;
          switch(*s)
            {
              case ' ': if (*(s+1)==' ') {best=20; l=2;} break;
              case '-':if ((*(s+1)=='-') && (*(s+2)=='-')) {best=7; l=3;} break;
              case '\'': if (*(s+1)==' ') {best=123; l=2;} break;
              case '+': if (*(s+1)=='+') {best=24; l=2;} break;
              case ';': if (*(s+1)==' ') {best=23; l=2;} break;
              case ',': if (*(s+1)==' ') {best=21; l=2;} break;
              case '=': if (*(s+1)=='=') {best=121; l=2;} break;
              case ':': switch(*(s+1)) {
                          case '-': best=122; l=2; break;
                          case ' ': best=4; l=2; break;} break;
              case '.': switch(*(s+1)) {
                          case '.': best=19; l=2; break;
                          case ' ': best=22; l=2; break;} break;
              case 'M':if ((*(s+1)=='S') &&
                           (*(s+2)=='G') &&
                           (*(s+3)=='I') &&
                           (*(s+4)=='D') &&
                           (*(s+5)==':') &&
                           (*(s+6)==' ')) {best=2; l=7;} break;
              case 'P':if ((*(s+1)=='A') &&
                           (*(s+2)=='T') &&
                           (*(s+3)=='H') &&
                           (*(s+4)==':') &&
                           (*(s+5)==' ')) {best=3; l=6;} break;
              case 'S':if ((*(s+1)=='E') &&
                           (*(s+2)=='E') &&
                           (*(s+3)=='N') &&
                           (*(s+4)=='-') &&
                           (*(s+5)=='B') &&
                           (*(s+6)=='Y') &&
                           (*(s+7)==':') &&
                           (*(s+8)==' ')) {best=1; l=9;} break;
              case 'a': switch(*(s+1)) {
                          case ' ': best=30; l=2; break;
                          case 'l': best=15; l=2; break;
                          case '\'': best=25; l=2; break;} break;
              case 'b': switch(*(s+1)) {
                          case 'b': best=37; l=2; break;
                          case 'a': best=38; l=2; break;
                          case 'e': best=39; l=2; break;
                          case 'i': best=40; l=2; break;
                          case 'o': best=41; l=2; break;
                          case 'u': best=42; l=2; break;} break;
              case 'c': switch(*(s+1)) {
                          case 'h': if (*(s+2)=='i') {best=9; l=3;} else if (*(s+2)=='e') {best=8; l=3;}; break;
                          case 'c': best=43; l=2; break;
                          case 'a': best=44; l=2; break;
                          case 'e': best=45; l=2; break;
                          case 'i': best=46; l=2; break;
                          case 'o': best=47; l=2; break;
                          case 'u': best=48; l=2; break;} break;
              case 'd': switch(*(s+1)) {
                          case 'd': best=49; l=2; break;
                          case 'a': best=50; l=2; break;
                          case 'e': best=51; l=2; break;
                          case 'i': best=52; l=2; break;
                          case 'o': best=53; l=2; break;
                          case 'u': best=54; l=2; break;} break;
              case 'e': switch(*(s+1)) {
                          case ' ': best=31; l=2; break;
                          case 'd': best=16; l=2; break;
                          case '\'': best=26; l=2; break;} break;
              case 'f': switch(*(s+1)) {
                          case 'f': best=55; l=2; break;
                          case 'a': best=56; l=2; break;
                          case 'e': best=57; l=2; break;
                          case 'i': best=58; l=2; break;
                          case 'o': best=59; l=2; break;
                          case 'u': best=60; l=2; break;} break;
              case 'g': switch(*(s+1)) {
                          case 'h': if (*(s+2)=='i') {best=11; l=3;} else if (*(s+2)=='e') {best=10; l=3;}; break;
                          case 'g': best=61; l=2; break;
                          case 'a': best=62; l=2; break;
                          case 'e': best=63; l=2; break;
                          case 'i': best=64; l=2; break;
                          case 'o': best=65; l=2; break;
                          case 'u': best=66; l=2; break;} break;
              case 'h': switch(*(s+1)) {
                          case 'i': best=36; l=2; break;
                          case 'a': best=124; l=2; break;
                          case 'o': best=125; l=2; break;} break;
              case 'i': switch(*(s+1)) {
                          case ' ': best=32; l=2; break;
                          case 'l': best=14; l=2; break;
                          case '\'': best=27; l=2; break;} break;
              case 'l': switch(*(s+1)) {
                          case 'l': best=67; l=2; break;
                          case 'a': best=68; l=2; break;
                          case 'e': best=69; l=2; break;
                          case 'i': best=70; l=2; break;
                          case 'o': best=71; l=2; break;
                          case 'u': best=72; l=2; break;} break;
              case 'm': switch(*(s+1)) {
                          case 'm': best=73; l=2; break;
                          case 'a': best=74; l=2; break;
                          case 'e': if((*(s+2)=='n') && (*(s+3)=='t')) {best=6; l=4;} else {best=75; l=2;} break;
                          case 'i': best=76; l=2; break;
                          case 'o': best=77; l=2; break;
                          case 'u': best=78; l=2; break;} break;
              case 'n': switch(*(s+1)) {
                          case 'n': best=79; l=2; break;
                          case 't': best=35; l=2; break;
                          case 'a': best=80; l=2; break;
                          case 'e': best=81; l=2; break;
                          case 'i': best=82; l=2; break;
                          case 'o': best=83; l=2; break;
                          case 'u': best=84; l=2; break;} break;
              case 'o': switch(*(s+1)) {
                          case ' ': best=33; l=2; break;
                          case '\'': best=28; l=2; break;} break;
              case 'p': switch(*(s+1)) {
                          case 'p': best=85; l=2; break;
                          case 'r': best=17; l=2; break;
                          case 'a': best=86; l=2; break;
                          case 'e': best=87; l=2; break;
                          case 'i': best=88; l=2; break;
                          case 'o': best=89; l=2; break;
                          case 'u': best=90; l=2; break;} break;
              case 'q': if (*(s+1)=='u') {best=126; l=2;} break;
              case 'r': switch(*(s+1)) {
                          case 'r': best=91; l=2; break;
                          case 'a': best=92; l=2; break;
                          case 'e': best=93; l=2; break;
                          case 'i': best=94; l=2; break;
                          case 'o': best=95; l=2; break;
                          case 'u': best=96; l=2; break;} break;
              case 's': switch(*(s+1)) {
                          case 's': best=97; l=2; break;
                          case 't': best=18; l=2; if (*(s+2)=='r') {best=12; l=3;} break;
                          case 'a': best=98; l=2; break;
                          case 'e': best=99; l=2; break;
                          case 'i': best=100; l=2; break;
                          case 'o': best=101; l=2; break;
                          case 'u': best=102; l=2; break;} break;
              case 't': switch(*(s+1)) {
                          case 't': best=103; l=2; break;
                          case 'a': best=104; l=2; break;
                          case 'e': best=105; l=2; break;
                          case 'i': best=106; l=2; break;
                          case 'o': best=107; l=2; break;
                          case 'u': best=108; l=2; break;} break;
              case 'u': switch(*(s+1)) {
                          case ' ': best=34; l=2; break;
                          case '\'': best=29; l=2; break;} break;
              case 'v': switch(*(s+1)) {
                          case 'v': best=109; l=2; break;
                          case 'a': best=110; l=2; break;
                          case 'e': best=111; l=2; break;
                          case 'i': best=112; l=2; break;
                          case 'o': best=113; l=2; break;
                          case 'u': best=114; l=2; break;} break;
              case 'z': switch(*(s+1)) {
                          case 'z': best=115; l=2; break;
                          case 'a': best=116; l=2; break;
                          case 'e': best=117; l=2; break;
                          case 'i': best=118; l=2; if ((*(s+2)=='o') && (*(s+3)=='n')) {best=5; l=4;} break;
                          case 'o': best=119; l=2; break;
                          case 'u': best=120; l=2; break;} break;
            }
          if (best==127)
            {if ((*s<128) || (*s==141)) fputc(*s,f); else {fputc(128,f); fputc(*s-127,f);} s++;}
          else
            {fputc(128+best,f); s+=l;}
        }
    }
  fputc(0,f);
}


unpipstring(char cr,unsigned char *s,FILE *f)
{
  while (*s)
    {
      if (*s!=10)
        {
          if ((*s==141) || (*s==13)) *s=cr;
          if (*s<128)
            fputc(*s,f);
          else
            {
              if (*s==128)
                {s++; fputc((*s)+127,f);}
              else
                fputs(pip[*s-128],f);
            }
        }
      s++;
    }
}


unpipfile(unsigned char *s,FILE *f)
{
  char *t;
  while(*s=fgetc(f))
    {
      if (*s==128)
        *s=fgetc(f)+127;
      else
        if (*s>128)
          {
            t=pip[*s-128];
            while (*t) {*s=*t; s++; t++;}
            *s=0; s--;
          }
      s++;
    }
}


read0(unsigned char *s,FILE *f,unsigned int mxlen,char truncate)
{
  while (mxlen && (*s=fgetc(f)) && !feof(f)) {s++; mxlen--;}
  if(*s==0) return 0;
  *s=0;
  if(truncate)
    while ((*s=fgetc(f)) && !feof(f));
  return -1;
}


readfile(unsigned char *s,unsigned char *fn)
{
  FILE *f;
  if ((f=fopen(fn,"rb"))==NULL) {free(s); esci("Unable to open input file");}
  while (!feof(f)) {*s=fgetc(f); if (*s!=10) s++;}
  s--; /* to skip last *s, that is a EOF */
  if (*(s-1)==26)
    {*(s-1)=13; *s=0;}
  else
    {*s=13; *(s+1)=0;}
  fclose(f);
}


write0(unsigned char *s,FILE *f)
{
  while (*s) {if (*s!=10) fputc(*s,f); s++;}
  fputc(0,f);
}


writemex(unsigned char *s,FILE *f,char ctrl_a)
{
  while (*s) {fputc((*s&127)==13?'\n':((*s==1)?ctrl_a:*s),f); s++;}
}

