#include <stdlib.h>
#include <string.h>
#include "strlist.h"

stringlist *cons(char *s,stringlist*l)
{
  stringlist*t;
  t=(stringlist*)malloc(sizeof(stringlist));
  strcpy(t->element,s);
  t->next=l;
  return t;
}


char *car(stringlist*l)
{
  return l->element;
}


stringlist* cdr(stringlist*l)
{
  return l->next;
}


void garbage_collect(stringlist*l)
{
  while(l)
    {
      free(l);
      l=l->next;
    }
}
